<?php
/*
	@! MADISS
	@@ MAke DIgital Signage Simple
	@@ Version 2.1.1 (02/2018)
-----------------------------------------------------------------------------
	** author: Benoît FACCHINETTI
	** Site: http://benserveur.fr.cr/MADISS
	** email: benoitfacchinetti@gmail.com
-----------------------------------------------------------------------------
	@@package: Admin
	@@version: 2.0
*/
if(!defined('IN_MADISS')){define('IN_MADISS', true);} //On fait en sorte que les includes sachent qu'ils sont appelé par nos pages et non directement par le navigateur.
require_once('init.php');
if(!isset($_SESSION['user_id']) OR $_SESSION['user_id'] == NULL OR $_SESSION['user_droit'] > '3'){ echo "<meta http-equiv=\"refresh\" content=\"0;url=enter.php\" />"; exit;}
// var_dump($_USERS);

 //DEBUT TRAITEMENT
$module_actif = 0;
$module_inactif = 0;
$page_actif = 0;
$page_inactif = 0;
$scrol_actif = 0;
$scrol_inactif = 0;
$ecrans_actif = 0;
$ecrans_inactif = 0;
$ecrans_new = 0;
$ecrans_noco = 0;

include_once('functions/DB/lesaviezvous.php');
$LeSaviezVousKey = array_rand($LeSaviezVousList);

$list_all = glob('DOCS/*.*.*'); //liste tout les modules et pages
foreach($list_all as $mod_key => $mod_value){
	$all_infos = explode('.',$mod_value);
	if($all_infos[3] == 'php'){ //c'est un module
		if($all_infos[1] == 'on'){ // il est actif
			$module_actif = $module_actif+1;
		}else{ // inactif
			$module_inactif = $module_inactif+1;
		}
	}else{ //c'est pas un module, donc une page.
		$affInterval = explode('_',$all_infos[1]);
		if(!isDateOld($affInterval[1])){ // il est actif
			$page_actif = $page_actif+1;
		}else{ // inactif
			$page_inactif = $page_inactif+1;
		}
	}
}

$list_scrol = glob('DOCS/scrolling/*.*.*'); //liste tout les scrolling
foreach($list_scrol as $scrol_key => $scrol_value){
	$scrol_infos = explode('.',$scrol_value);
	if($scrol_infos[3] == 'html'){ //c'est un scrolling
		if($scrol_infos[1] == 'on'){ // il est actif
			$scrol_actif = $scrol_actif+1;
		}else{ // inactif
			$scrol_inactif = $scrol_inactif+1;
		}
	}
}

//Récupere les infos des écrans !
$list_ecrans = _GETSCREANS();
foreach ($list_ecrans as $ecran_infos){
	$ecran_info = _GETSCREANSINFOS($ecran_infos);
	if(isset($ecran_info['actif']) && $ecran_info['actif'] == 'true'){
		$ecrans_actif = $ecrans_actif+1;
	}elseif(isset($ecran_info['actif']) && $ecran_info['actif'] == 'null'){
		$ecrans_new = $ecrans_new+1;
	}elseif(isset($ecran_info['actif']) && $ecran_info['actif'] == 'false'){
		$ecrans_inactif = $ecrans_inactif+1;
	}
	if(isset($ecran_info['last_connect'])){
		$heure_a = date("H");
		$elc = explode(" ",$ecran_info['last_connect']);
		$elc_h = explode(":", $elc[1]);
		$lc = $heure_a - $elc_h[0];
		if($lc <= "-2" or $lc >= "2"){
			$ecrans_noco = $ecrans_noco + 1;
		}
	}
}

//On vérifie qu'il n'y ait pas trop de page et modules inactifs !
if($page_inactif >= 10){
	$AdminMessage[] = '<div class="col-md-12">
					<div class="alert bg-warning" role="alert">
						<svg class="glyph stroked flag"><use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#stroked-flag"></use></svg> Vous avez beaucoup de pages inactives ('.$page_inactif.'), si elles ne sont plus utiles, vous avez la possibilité de les supprimer !
					</div>
				</div>';
}
if($scrol_inactif >= 10){
	$AdminMessage[] = '<div class="col-md-12">
					<div class="alert bg-warning" role="alert">
						<svg class="glyph stroked flag"><use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#stroked-flag"></use></svg> Vous avez beaucoup de scrollings inactifs ('.$scrol_inactif.'), s’ils ne sont plus utiles, vous avez la possibilité de les supprimer !
					</div>
				</div>';
}
if($ecrans_new >= 1){
	$PlayerMessage[] = '
					<div class="alert bg-primary" role="alert">
						<svg class="glyph stroked monitor"><use xlink:href="#stroked-monitor"/></svg> Vous avez un ou plusieurs nouvel écrans (en l\'occurrence '.$ecrans_new.'), qui attendent votre approbation pour afficher du contenu !
					</div>';
}
if($ecrans_noco >= 1){
	$PlayerMessage[] = '
					<div class="alert bg-warning" role="alert">
						<svg class="glyph stroked monitor"><use xlink:href="#stroked-monitor"/></svg> '.$ecrans_noco.' écran(s) non connecté(s) depuis 2h ou +
					</div>';
}
//GESTION NOTES
if(isset($_POST['notes'])){
	$data_notes = $_POST['notes'];
	if(_UPDATECONFIG('bloc_notes', $data_notes)){
		$message = '<div class="col-md-12">
						<div class="alert bg-success" role="alert">
							<svg class="glyph stroked checkmark"><use xlink:href="#stroked-checkmark"/></svg> Note mise à jour !
						</div>
					</div>';
	}else{
		$message = '<div class="col-md-12">
						<div class="alert bg-danger" role="alert">
							<svg class="glyph stroked cancel"><use xlink:href="#stroked-cancel"/></svg> Impossible de mettre à jour la note !
						</div>
					</div>';
	}
}
// GESTION ESPACE DISQUE

$allowed_space = _GETCONFIG('allowed_space')['value'];
$space_used = getFolderSize("./DOCS/");
$persent_used = ($space_used/$allowed_space)*100;
if($persent_used >= 80){
	$chartId = 'easypiechart-red';
}elseif($persent_used > 65 && $persent_used < 80){
	$chartId = 'easypiechart-orange';
}else{
	$chartId = 'easypiechart-blue';
}

//FIN TRAITEMENT

include('template/template.php');
include('template/header.php');
template_header($_SESSION['service_name']);

include('template/admin.php');

include('template/footer.php');
?>
