<?php
/*
	@! MADISS
	@@ MAke DIgital Signage Simple
	@@ Version 2.1.1 (02/2018)
-----------------------------------------------------------------------------	
	** author: Benoît FACCHINETTI 
	** Site: http://benserveur.fr.cr/MADISS
	** email: benoitfacchinetti@gmail.com
-----------------------------------------------------------------------------
	@@package: Functions
	@@version: 2.0
*/
if(!defined('IN_MADISS')) die('Action impossible ! (erreur: Script could not be opened alone)'); //Vérifi si appeler par nos scripts

function _SECURISE($string)
{
	$string = htmlspecialchars(htmlentities($string));
	
	return $string;
}

function _UPDATECONFIG($name, $value)
{ 
	global $pdo;
	try {
			$q = "UPDATE 'config' SET `value` = :value WHERE `name` = :name";
			$check_query = $pdo->prepare($q);
			$check_query->bindParam(':name', $name, PDO::PARAM_STR);
			$check_query->bindParam(':value', $value, PDO::PARAM_STR);
			$check_query->execute();
		} catch(PDOException $e) {
			return false;
		}
		return true;
}

function _GETCONFIG($name)
{ 
	global $pdo;
	try {
			$q = "SELECT * FROM 'config' WHERE `name` = :name";
			$check_query = $pdo->prepare($q);
			$check_query->bindParam(':name', $name, PDO::PARAM_STR);
			$check_query->setFetchMode(PDO::FETCH_ASSOC);
			$check_query->execute();
		} catch(PDOException $e) {
			// echo $e;
		}
		$out = $check_query->fetch();
	return $out;
}

function _GETMODULESINFOS($module_name)
{ 
	global $pdo;
	
	try {
			$q = "SELECT * FROM 'modules' WHERE `module_name` = :name";
			$check_module = $pdo->prepare($q);
			$check_module->bindParam(':name', $module_name, PDO::PARAM_STR);
			$check_module->setFetchMode(PDO::FETCH_ASSOC);
			$check_module->execute();
		} catch(PDOException $e) {
			// echo $e;
		}
		$out_module = $check_module->fetch();
	return $out_module;
}

function _UPDATEMODULEINFOS($module_name, $value)
{ 
	global $pdo;
	try {
			$q = "UPDATE 'modules' SET `module_param` = :value WHERE `module_name` = :name";
			$check_query = $pdo->prepare($q);
			$check_query->bindParam(':name', $module_name, PDO::PARAM_STR);
			$check_query->bindParam(':value', $value, PDO::PARAM_STR);
			$check_query->execute();
		} catch(PDOException $e) {
			return false;
		}
		return true;
}

function _GETSCREANS_old($file = null)
{
	if($file === null)
	{
		$file = __DIR__.DIRECTORY_SEPARATOR.'DB/screans_management.json';
	}
	if(file_exists($file))
	{
		$configuration = json_decode(file_get_contents($file), true);
		return $configuration;
	}else{_LOGS('Gestion des écrans', 'ce fichier n\'existe plus !', 'error');}
}

function _GETSCREANS($file = null)
{
	$arr = array();
	if($file === null)
	{
		$file = 'functions/DB/screens/';
	}
	if(file_exists($file))
	{
		$list = glob($file."*.json");
		foreach($list as $liste){
			$arr[] = substr($liste, 21, -5);
		}
		return $arr;
	}else{_LOGS('Gestion des écrans', 'ce dossier n\'existe plus !', 'error');}
}

function _GETSCREANSINFOS($data = null)
{
	if($data === null)
	{
		$file = 'functions/DB/screens/CONFIG.json';
	}else{
		$file = 'functions/DB/screens/'.$data.'.json';
	}
	if(file_exists($file))
	{
		$configuration = json_decode(file_get_contents($file), true);
		return $configuration;
	}else{_LOGS('Gestion des écrans', 'le fichier '.$file.' n\'existe plus !', 'error');}
}

function _UPDATESCREANS($data_array, $data = null){
	if($data === null)
	{
		$file = 'functions/DB/screens/CONFIG.json';
	}else{
		$file = 'functions/DB/screens/'.$data.'.json';
	}
	if(!is_array($data_array)){
		$data_array = array();
	}
	if(!file_exists($file))
	{
		touch($file);
		$joutput = json_encode($data_array);
		$createfile = file_put_contents($file, $joutput);
	}else{
		$arr = json_decode(file_get_contents($file), true);
		if(!is_array($arr) or $arr == null or $arr == false){
			unlink($file); // On supprime tout le fichier
			_LOGS('Gestion des écrans', 'le fichier '.$data.' fut corrompu !', 'error');touch($file);
			$joutput = json_encode($data_array);
			$createfile = file_put_contents($file, $joutput);
		}else{
			$output = array_replace_recursive($arr, $data_array);
			$joutput = json_encode($output);
			$createfile = file_put_contents($file, $joutput);
		}
		return true;
	}
}

function _LOGS($SCID, $message, $type_log = 'info', $dirurl = './')
{
	// $type_log = "info/notice/warning/error";
	
	//ce tableau ne sera pas associatif, car c'est un tableau classique à indice
	$table=array();
	
	$filedir = __DIR__.DIRECTORY_SEPARATOR.'DB'.DIRECTORY_SEPARATOR.'SCLogs'.DIRECTORY_SEPARATOR.'SC_logs_'.date("m-Y").'.json';
	if(is_file($filedir))
	{
		$filedata = json_decode(file_get_contents($filedir));
		$table = $filedata;
	}else{
		touch($filedir);
	}

	//celui-ci oui
	$updatetraqueur = array(
		"ecran" => $SCID,
		"date" => date("d-m-Y"),
		"time" => date("H:i:s"),
		"type_log" => $type_log,
		"action" => $message
	);
	array_unshift($table,$updatetraqueur); 
	
	$monfichier = fopen($filedir, 'w+');
 
	fseek($monfichier, 0); // On remet le curseur au début du fichier
	fputs($monfichier, json_encode($table)); // On écrit le nouveau nombre de pages vues
	 
	fclose($monfichier);
}

function _GETLOGS($dirurl='./', $date, $filter = "all", $param = null)
{

	$outTable = array();
	if(empty($param)){$param = $_IDB_PERSO['nom_perso'];}
	if(empty($date)){$date = date("d-m-Y");}
	
	$filedir = $dirurl.'modules/actiontraqueur/traqueur_'.$date.'.json';
	if(is_file($filedir))
	{
		$filedata = json_decode(file_get_contents($filedir));
		// var_dump($filedata);
		foreach($filedata as $key => $increments)
		{
			switch($filter){
				case "nom":
					if($increments->nom == $param)
					{
						// echo $increments->time .': '.$increments->action."\n";
						$outTable[] = array('time' => $increments->time, 'name' => $increments->nom, 'action' => $increments->action);
					}
					break;
				case "time":
					if($increments->time >= $param[0] and $increments->time <= $param[1])
					{
						// echo $increments->time .': '.$increments->action."\n";
						$outTable[] = array('time' => $increments->time, 'name' => $increments->nom, 'action' => $increments->action);
					}
					break;
				case "all":
					
						// echo $increments->time .': '.$increments->nom.' '.$increments->action."\n";
						$outTable[] = array('time' => $increments->time, 'name' => $increments->nom, 'action' => $increments->action);
		
					break;
			}
			// print_r($increments->action);
			
			
		}
		return $outTable;
	}
	return false;
}

function getFolderSize($path){
	$size = 0;
	foreach(new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path)) as $file){
		$size += $file->getSize();
	}
 
	
	$size = round($size/(1024*1024),2);
 
	return $size;
}

function spaceAvailable($path){
	
	$allowed_space = _GETCONFIG('allowed_space')['value'];
	$space_used = getFolderSize($path);
	if($space_used < $allowed_space){
		return true;
	}else{
		return false;
	}
}

function XMLReader($url){

	if(is_object($flux = simplexml_load_file($url)))
	{
	   $donnee = $flux->channel;

	   //Lecture des données

	   return $donnee;
	   
	}else return false;
}

function get_browser_name($user_agent)
{
    if (strpos($user_agent, 'Opera') || strpos($user_agent, 'OPR/')){ return 'Opera';}
    elseif (strpos($user_agent, 'Edge')){ return 'Edge';}
    elseif (strpos($user_agent, 'Chrome')){ return 'Chrome';}
    elseif (strpos($user_agent, 'Safari')){ return 'Safari';}
    elseif (strpos($user_agent, 'Firefox')){ return 'Firefox';}
    elseif (strpos($user_agent, 'MSIE') || strpos($user_agent, 'Trident/7')){ return 'Internet Explorer';}
    
    return 'Other';
}

function get_client_ip() {
	//Retourne la vraie adresse IP du client
        return (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
}

function get_serveur_ip() {
	//Retourne la vraie adresse IP du serveur
        return $_SERVER['SERVER_ADDR'];
}

function MDPCrypt($mdp){

	return password_hash($mdp, PASSWORD_BCRYPT);
}

function VerifyMDP($mdp, $hash){

	return password_verify($mdp, $hash);
}

function select_plugin(){
	global $_SESSION;
	
	$root_dir = 'DOCS';
	//liste des fichiers (plugins) actifs
	if(!is_array($_SESSION['last_page'])){$_SESSION['last_page'] = array();} //On definit la session en tableau

	$list_plugin = glob('./'.$root_dir.'/*.on.*'); //on liste tout les modules et page actif
	$nb_plugin = count($list_plugin)-1; // On compte le nombre total de modules et pages

	foreach($list_plugin as $key => $name){
		//Si on à passer tout les modules on vide la session pour recommencer
		if(in_array($nb_plugin, $_SESSION['last_page'])){
			$_SESSION['last_page'] = array();
		}
		if(!in_array($key, $_SESSION['last_page'])){// On met a jour le tableau et on assigne le nouveau module à afficher
			$_SESSION['last_page'][] = $key;
			$plugin_selected = $name;
			break;
		}
	}
	$out = array('p_infos' => explode('.',$plugin_selected), 'p_selected' => $plugin_selected);
	// Recupere les infos du module a afficher
	return $out;
}

function select_scrolling(){
	global $_SESSION;
	
	$root_dir = 'DOCS/scrolling';
	//liste des fichiers (plugins) actifs
	if(!is_array($_SESSION['last_slider'])){$_SESSION['last_slider'] = array();} //On definit la session en tableau

	$list_slider = glob('./'.$root_dir.'/Scrolling_*.on.*.html'); //on liste tout les slider actif
	$nb_slider = count($list_slider)-1; // On compte le nombre total de slider

	foreach($list_slider as $key => $name){
		//Si on à passer tout les slider on vide la session pour recommencer
		if(in_array($nb_slider, $_SESSION['last_slider'])){
			$_SESSION['last_slider'] = array();
		}
		if(!in_array($key, $_SESSION['last_slider'])){// On met a jour le tableau et on assigne le nouveau module à afficher
			$_SESSION['last_slider'][] = $key;
			$slider_selected = $name;
			break;
		}
	}
	$out = array('s_infos' => explode('.',$slider_selected), 's_selected' => $slider_selected);
	// Recupere les infos du module a afficher
	return $out;
}

function human_filesize($file, $decimals = 1) {
	$bytes = filesize($file);
	$sz = 'BKMGTP';
	$factor = floor((strlen($bytes) - 1) / 3);
	return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
}

function base64url_encode($data) { 
  return rtrim(strtr(base64_encode($data), '+/', '-_'), '='); 
} 

function base64url_decode($data) { 
  return base64_decode(str_pad(strtr($data, '-_', '+/'), strlen($data) % 4, '=', STR_PAD_RIGHT)); 
} 

//GESTION DES DATES D'AFFICHAGE DES PAGES
function isDateOld($toCompare, $dateRef = null){
	if($dateRef == null){$dateRef = date("Y-m-d");}
	$datetime1 = date_create($dateRef);
	$datetime2 = date_create($toCompare);
	$interval = (array) date_diff($datetime1, $datetime2);
	if($interval['invert'] == 1){
		return true;
	}else{
		return false;
	}
}

function dateInterval($startDate, $endDate){
	$today = date_create(date("Y-m-d"));
	$startDate = date_create($startDate);
	$endDate = date_create($endDate);
	
	$startInterval = (array) date_diff($today, $startDate);
	$endInterval = (array) date_diff($today, $endDate);
	// var_dump($startInterval);
	// var_dump($endInterval);
	if(($startInterval['invert'] == 1 OR $startInterval['days'] == '0') AND $endInterval['invert'] == 0){
		return true;
	}else{
		return false;
	}
}
?>