<?php
/*
	@! MADISS
	@@ MAke DIgital Signage Simple
	@@ Version 2.1.1 (02/2018)
-----------------------------------------------------------------------------	
	** author: Benoît FACCHINETTI 
	** Site: http://benserveur.fr.cr/MADISS
	** email: benoitfacchinetti@gmail.com
-----------------------------------------------------------------------------
	@@package: API
	@@version: 2.0
*/
if(!defined('IN_MADISS')){define('IN_MADISS', true);} //On fait en sorte que les includes sachent qu'ils sont appelé par nos pages et non directement par le navigateur.
if(session_id() == "" && !isset($_SESSION)){ session_start();}

require_once('./functions/functions.php');
$Server_url = dirname($_SERVER['SERVER_PROTOCOL']).'://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['REQUEST_URI']);
$json = array();
$root_dir = 'DOCS';
// $json['command'] = $Server_url; //on liste tout les slider actif

$list_screans = _GETSCREANS();

if(isset($_GET['SCID']) && $_GET['SCID'] != null){
	$SCID = _SECURISE($_GET['SCID']);
	$decoded = json_decode(base64url_decode($SCID),true);
	//TODO : VERIFIER QUE LE SCID EST VALIDE !
	
	if(in_array($SCID, $list_screans)){	//si l'écran est dans la liste des écrans
		$screen_info = _GETSCREANSINFOS($SCID);
		if($screen_info['actif'] == 'true' or _GETSCREANSINFOS('CONFIG')['all_allow'] == 'true'){	//si l'écran est actif ou que la règle "all_allow" et vrais
			//On enregistre la date et l'heure d'access dans un fichier
			$new_tentative = array('last_connect' => date("d-m-Y H:i:s"));
			_UPDATESCREANS($new_tentative, $SCID);
			// Demande au player les infos utiles manquantes
			if(empty($screen_info['ip_locale'])){
				$json['SCCMD'] = 192; // Demande IP locale
			}elseif(empty($screen_info['player_version'])){
				$json['SCCMD'] = 060; // Demande IP locale
			}else{
				$json['SCCMD'] = null;
			}
			//* FIN Demande au player les infos utiles manquantes
			//POST REQUEST
			if(isset($_POST) && $_POST != null){
				if(!empty($_POST['ip_locale'])){
					$new_tentative = array('last_connect' => date("d-m-Y H:i:s"), 'ip_locale' => _SECURISE($_POST['ip_locale']));
					_UPDATESCREANS($new_tentative, $SCID);
					_LOGS($SCID, 'a communiqué son IP locale : '._SECURISE($_POST['ip_locale']));
				}elseif(!empty($_POST['maj_status'])){
					if(is_array($_POST['maj_status'])){
						_LOGS($SCID, 'MAJ : '._SECURISE($_POST['maj_status']['message']), $_POST['maj_status']['type']);
					}else{
						_LOGS($SCID, 'MAJ : '._SECURISE($_POST['maj_status']));
					}
				}elseif(!empty($_POST['player_version'])){
					$new_tentative = array('last_connect' => date("d-m-Y H:i:s"), 'player_version' => _SECURISE($_POST['player_version']));
					_UPDATESCREANS($new_tentative, $SCID);
					_LOGS($SCID, 'a communiqué sa version : '._SECURISE($_POST['player_version']));
				}else{
					$json['statusCode'] = 500; //Server Error
				}
				// $json['return'] = json_encode($_POST);
			//* FIN POST REQUEST
			}else{
				$json['statusCode'] = 200; //OK
				$plugins = glob(''.$root_dir.'/*.*.*'); //on liste tout les pages
				$scrollings = glob(''.$root_dir.'/scrolling/Scrolling_*.on.*.html'); //on liste tout les sliders actif
				foreach($plugins as $out_p){
					$plugin_name = explode('.',$out_p);
					// On affiche les pages dont les dates d'affichages correspondent à la date du jour
					if($plugin_name[3] != 'php'){
						$plugin_dates = explode('_', $plugin_name[1]);
						if(dateInterval($plugin_dates[0], $plugin_dates[1])){
							$json['plugin'][] = $Server_url.'/'.$out_p;
						}
					}else{
						//On affiche les modules mais seulement ceux qui sont actif (on)
						if($plugin_name[1] == 'on'){
							$json['plugin'][] = $Server_url.'/'.$out_p;
						}
					}
				}
				foreach($scrollings as $out_s){
					$json['scrolling'][] = $Server_url.'/'.$out_s;
				}
			}
		}else{
			// On enregistre la tentative dans un fichier
			$new_tentative = array('last_connect' => date("d-m-Y H:i:s"));
			_UPDATESCREANS($new_tentative, $SCID);
			$json['statusCode'] = 401; //Request Unauthorized
			// http_response_code(401);
		}
	}else{
		// On enregistre la tentative dans un fichier
		// $new_tentative = array($SCID => array('activ' => 'false', 'last_connect' => date("d-m-Y H:i:s")));
		$new_tentative = array('SCID' => $SCID, 'actif' => 'null', 'ip_locale' => '', 'infos_libre' => '', 'last_connect' => date("d-m-Y H:i:s"));
		_UPDATESCREANS($new_tentative, $SCID);
		$json['statusCode'] = 403; //Request Forbidden
		// http_response_code(403);
	}
}else{
	$json['statusCode'] = 400; //Bad Request
	// http_response_code(400);
}
header('Content-type: application/json');
$json = json_encode($json);
echo $json;
// var_dump($json);
?>